# Gst Namespace Reference

## Classes

class | Adder
| Gst::Adder - adder plugin. More...
class | AlsaMixer
| Gst::AlsaMixer - alsamixer plugin. More...
class | AlsaSink
| Gst::AlsaSink - alsasink plugin. More...
class | AlsaSrc
| Gst::AlsaSrc - alsasrc plugin. More...
class | AudioClock
| Gst::AudioClock - Helper object for implementing audio clocks. More...
class | AudioConvert
| Gst::AudioConvert - audioconvert plugin. More...
class | AudioFilter
| Gst::AudioFilter - Base class for simple audio filters. More...
class | AudioResample
| Gst::AudioResample - audioresample plugin. More...
class | AudioSink
| Gst::AudioSink - Simple base class for audio sinks. More...
class | AudioSrc
| Gst::AudioSrc - Simple base class for audio sources. More...
class | AudioTestSrc
| Gst::AudioTestSrc - audiotestsrc plugin. More...
class | BaseAudioSink
| Gst::BaseAudioSink - Base class for audio sinks. More...
class | BaseAudioSrc
| Gst::BaseAudioSrc - Base class for audio sources. More...
class | BaseSink
| Gst::BaseSink - Base class for sink elements. More...
class | BaseSrc
| Gst::BaseSrc - Base class for getrange based source elements. More...
class | BaseTransform
| Gst::BaseTransform - Base class for simple transform filters. More...
class | Bin
| Gst::Bin - Base class and element that can contain other elements. More...
class | Buffer
| Gst::Buffer - Data-passing buffer type, supporting sub-buffers. More...
class | Bus
| Gst::Bus - Asynchronous message bus subsystem. More...
class | Caps
| Gst::Caps (capabilities) are lightweight objects describing media formats. More...
class | CapsFilter
| Gst::CapsFilter - capsfilter plugin. More...
class | CddaBaseSrc
| Gst::CddaBaseSrc - Base class for CD digital audio (CDDA) sources. More...
class | CdParanoiaSrc
| Gst::CdParanoiaSrc - cdparanoiasrc plugin. More...
class | ChildProxy
| Gst::ChildProxy - An interface for multi child elements. More...
class | ClockID
| A datatype to hold the handle to an outstanding sync or async clock callback. More...
class | Clock
| Gst::Clock - Abstract class for global clocks. More...
class | ClockOverlay
| Gst::ClockOverlay - clockoverlay plugin. More...
class | ColorBalance
| Gst::ColorBalance - Interface for adjusting color balance settings. More...
class | ColorBalanceChannel
| Gst::ColorBalanceChannel - Represents a color balance channel. More...
class | DecodeBin
| Gst::DecodeBin - decodebin plugin. More...
class | Element
| Gst::Element - Abstract base class for all pipeline elements. More...
class | ElementInterfaced
| Templated class used for casting Gst::Element to interfaces that its underlying gobject implements. More...
class | ElementFactory
| Gst::ElementFactory - Create Gst::Element from a factory. More...
class | CoreError
| The GStreamer core GError type. More...
class | LibraryError
| The GStreamer library GError type. More...
class | ResourceError
| The GStreamer resource GError type. More...
class | StreamError
| The GStreamer stream GError type. More...
class | Event
| Gst::Event - A structure describing events that are passed up and down a pipeline. More...
class | EventFlushStart
| A flush start event. More...
class | EventFlushStop
| A flush stop event. More...
class | EventEos
| An end of stream event. More...
class | EventNewSegment
| A new segment event. More...
class | EventTag
| A tag event. More...
class | EventBufferSize
| A buffer size event. More...
class | EventQos
| A QOS event. More...
class | EventSeek
| A seek event. More...
class | EventNavigation
| A Navigation event. More...
class | EventLatency
| A latency event. More...
class | FakeSink
| Gst::FakeSink - fakesink plugin. More...
class | FakeSrc
| Gst::FakeSrc - fakesrc plugin. More...
class | FdSink
| Gst::FdSink - fdsink plugin. More...
class | FdSrc
| Gst::FdSrc - fdsrc plugin. More...
class | FfmpegColorSpace
| Gst::FfmpegColorSpace - ffmpegcolorspace plugin. More...
class | FileSink
| Gst::FileSink - filesink plugin. More...
class | FileSrc
| Gst::FileSrc - filesrc plugin. More...
class | Filter
| Gst::Filter - A utility function to filter Lists. More...
class | FormatDefinition
| A format definition is used to get details of a Gst::Format by Gst::get_details(). More...
class | GDPDepay
| Gst::GDPDepay - gdpdepay plugin. More...
class | GDPPay
| Gst::GDPPay - gdppay plugin. More...
class | GhostPad
| Gst::GhostPad - Pseudo link pads. More...
class | GioSink
| Gst::GioSink - giosink plugin. More...
class | GioSrc
| Gst::GioSrc - giosrc plugin. More...
class | GioStreamSink
| Gst::GioStreamSink - giostreamsink plugin. More...
class | GioStreamSrc
| Gst::GioStreamSrc - giostreamsrc plugin. More...
class | Identity
| Gst::Identity - identity plugin. More...
class | IndexEntry
| The basic element of an index. More...
class | IndexGroup
| A group of related entries in an index. More...
class | IndexAssociation
| An association in an entry. More...
class | Index
| Gst::Index is used to generate a stream index of one or more elements in a pipeline. More...
class | IndexFactory
| Gst::IndexFactory - Create Indexes from a factory. More...
class | Interface
| Core interface implemented by Gst::Element instances that allows runtime querying of interface availability. More...
class | IteratorBase
| Gst::IteratorBase - Base class for classes that retrieve multiple elements in a thread safe way. More...
class | IteratorBasic
| Gst::IteratorBasic - Class that retrieves multiple elements in a thread safe way. More...
class | Iterator
| Gst::Iterator - Class that retrieve multiple reference counted elements in a thread safe way. More...
class | Message
| Gst::Message - Lightweight objects to signal the application of pipeline events. More...
class | MessageEos
| An end of stream message. More...
class | MessageError
| An error message. More...
class | MessageWarning
| A warning message. More...
class | MessageInfo
| An informational message. More...
class | MessageTag
| A tag message. More...
class | MessageBuffering
| A buffering message. More...
class | MessageStateChanged
| A state change message. More...
class | MessageStateDirty
| A state dirty message. More...
class | MessageClockProvide
| A clock provide message. More...
class | MessageClockLost
| A clock lost message. More...
class | MessageNewClock
| A new clock message. More...
class | MessageApplication
| An application message. More...
class | MessageElement
| An element specific message. More...
class | MessageCustom
| A custom message. More...
class | MessageSegmentStart
| A segment start message. More...
class | MessageSegmentDone
| A segment done message. More...
class | MessageDuration
| A duration message. More...
class | MessageLatency
| A latency message. More...
class | MessageAsyncStart
| An asynchronous start message. More...
class | MessageAsyncDone
| An asynchronous done message. More...
class | MiniObject
| This is a base class for some gstreamermm objects. More...
class | Mixer
| Gst::Mixer - Interface for elements that provide mixer operations. More...
class | MixerOptions
| Gst::MixerOptions - Options for elements that implement the* Gst::Mixer interface. More...
class | MixerTrack
| Gst::MixerTrack - A track in an element that implement the Gst::Mixer interface. More...
class | MultiQueue
| Gst::MultiQueue - multiqueue plugin. More...
class | Navigation
| Gst::Naviagtion - Interface for elements that provide navigation functionality. More...
class | Object
| Gst::Object - Base class for the GStreamer object hierarchy. More...
class | OggDemux
| Gst::OggDemux - oggdemux plugin. More...
class | OggMux
| Gst::OggMux - oggmux plugin. More...
class | Pad
| Gst::Pad - Object contained by elements that allows links to other elements. More...
class | PadTemplate
| Gst::PadTemplate - Describe the media type of a pad. More...
class | ParseError
| The different parsing errors that can occur. More...
class | Parse
| Gst::Parse - Get a pipeline from a text pipeline description. More...
class | Pipeline
| A Gst::Pipeline is a special Gst::Bin used as the toplevel container for the filter graph. More...
class | PlayBin2
| Gst::PlayBin2 - playbin2 plugin. More...
class | PluginError
| The plugin loading errors. More...
class | Plugin
| Gst::Plugin - Container for features loaded from a shared object module. More...
class | PluginFeature
| This is a base class for anything that can be added to a Gst::Plugin. More...
class | Preset
| Gst::Preset - helper interface for element presets. More...
class | PropertyProbe
| Gst::PropertyProbe - Interface for probing possible property values. More...
class | PushSrc
| Gst::PushSrc - Base class for push based source elements. More...
class | QueryTypeDefinition
| A query type definition is used to get details of a Gst::Query by Gst::Query::get_details(). More...
class | Query
| Gst::Query - Classes used to perform queries on pads and elements. More...
class | QueryApplication
| A custom application query object. More...
class | QueryConvert
| A convert query object. More...
class | QueryPosition
| A stream position query object. More...
class | QueryDuration
| A stream duration query object. More...
class | QueryLatency
| A latency query object. More...
class | QuerySeeking
| A seeking query object. More...
class | QueryFormats
| A formats query object. More...
class | QuerySegment
| A new segment query object. More...
class | QueryBuffering
| A new buffering query object. More...
class | Queue
| Gst::Queue - queue plugin. More...
class | Registry
| Gst::Registry - Abstract base class for management of Gst::Plugin objects. More...
class | Segment
| Gst::Segment - Class describing the configured region of interest in a media file. More...
class | Structure
| Gst::Structure - Generic structure containing fields of names and values. More...
class | SystemClock
| Gst::SystemClock - Default clock that uses the current system time. More...
class | TagList
| A List of tags and values used to describe media metadata. More...
class | TagSetter
| Gst::TagSetter - Gst::Element interface that allows setting and retrieval of media metadata. More...
class | Task
| Gst::Task - Abstraction of GStreamer streaming threads. More...
class | Tee
| Gst::Tee - tee plugin. More...
class | TextOverlay
| Gst::TextOverlay - textoverlay plugin. More...
class | TextRender
| Gst::TextRender - textrender plugin. More...
class | TheoraDec
| Gst::TheoraDec - theoradec plugin. More...
class | TheoraEnc
| Gst::TheoraEnc - theoraenc plugin. More...
class | TimeOverlay
| Gst::TimeOverlay - timeoverlay plugin. More...
class | Tuner
| Gst::Tuner - Interface for elements providing tuner operations. More...
class | TunerChannel
| Gst::TunerChannel - A channel from an element implementing the Gst::Tuner interface. More...
class | TunerNorm
| Gst::TunerNorm - Encapsulates information about the data format(s) for a Gst::TunerChannel. More...
class | TypeFind
| Gst::TypeFind - typefind plugin. More...
class | URIHandler
| Gst::URIHandler - An interface to ease URI handling in plugins. More...
class | Fourcc
| Represents a 4 byte identifier (used in codecs). More...
class | Fraction
| Represents a fraction. More...
class | IntRange
| Represents an integer range (min - max). More...
class | DoubleRange
| Represents a double range (min - max). More...
class | FractionRange
| Represents a fractional range. More...
class | VideoOrientation
| Gst::VideoOrientation - Interface for elements providing video orientation controls. More...
class | VideoRate
| Gst::VideoRate - videorate plugin. More...
class | VideoScale
| Gst::VideoScale - videoscale plugin. More...
class | VideoSink
| Gst::VideoSink - Base class for video sinks. More...
class | VideoTestSrc
| Gst::VideoTestSrc - videotestsrc plugin. More...
class | Volume
| Gst::Volume - volume plugin. More...
class | VorbisDec
| Gst::VorbisDec - vorbisdec plugin. More...
class | VorbisEnc
| Gst::VorbisEnc - vorbisenc plugin. More...
class | VorbisParse
| Gst::VorbisParse - vorbisparse plugin. More...
class | VorbisTag
| Gst::VorbisTag - vorbistag plugin. More...
class | XImageSink
| Gst::XImageSink - ximagesink plugin. More...
class | XML
| Gst::XML - XML save/restore operations of pipelines. More...
class | XOverlay
| XOverlay - Interface for setting/getting a Window on elements supporting it. More...
class | XvImageSink
| Gst::XvImageSink - xvimagesink plugin. More...

## Namespaces

namespace | Enums
namespace | Tag

## Typedefs

typedef GstClockTime | ClockTime
| A datatype to hold a time, measured in nanoseconds.
typedef GstClockTimeDiff | ClockTimeDiff
| A datatype to hold a timedifference, measured in nanoseconds.

## Enumerations

enum | AudioConvertDithering { AUDIO_CONVERT_DITHER_NONE, AUDIO_CONVERT_DITHER_RPDF, AUDIO_CONVERT_DITHER_TPDF, AUDIO_CONVERT_DITHER_TPDF_HF }
enum | AudioConvertNoiseShaping { AUDIO_CONVERT_NOISE_SHAPING_NONE, AUDIO_CONVERT_NOISE_SHAPING_ERROR_FEEDBACK, AUDIO_CONVERT_NOISE_SHAPING_SIMPLE, AUDIO_CONVERT_NOISE_SHAPING_MEDIUM, AUDIO_CONVERT_NOISE_SHAPING_HIGH }
enum | AudioTestSrcWave { AUDIO_TEST_SRC_WAVE_SINE, AUDIO_TEST_SRC_WAVE_SQUARE, AUDIO_TEST_SRC_WAVE_SAW, AUDIO_TEST_SRC_WAVE_TRIANGLE, AUDIO_TEST_SRC_WAVE_SILENCE, AUDIO_TEST_SRC_WAVE_WHITE_NOISE, AUDIO_TEST_SRC_WAVE_PINK_NOISE, AUDIO_TEST_SRC_WAVE_SINE_TAB, AUDIO_TEST_SRC_WAVE_TICKS }
enum | BaseAudioSinkSlaveMethod { BASE_AUDIO_SINK_SLAVE_RESAMPLE, BASE_AUDIO_SINK_SLAVE_SKEW, BASE_AUDIO_SINK_SLAVE_NONE }
enum | BaseAudioSrcSlaveMethod { BASE_AUDIO_SRC_SLAVE_RESAMPLE, BASE_AUDIO_SRC_SLAVE_RETIMESTAMP, BASE_AUDIO_SRC_SLAVE_SKEW, BASE_AUDIO_SRC_SLAVE_NONE }

enum

BufferFlag {
BUFFER_FLAG_READONLY = GST_MINI_OBJECT_FLAG_READONLY,
BUFFER_FLAG_PREROLL = GST_MINI_OBJECT_FLAG_READONLY << 0,
BUFFER_FLAG_DISCONT = GST_MINI_OBJECT_FLAG_READONLY << 1,
BUFFER_FLAG_IN_CAPS = GST_MINI_OBJECT_FLAG_READONLY << 2,
BUFFER_FLAG_GAP = GST_MINI_OBJECT_FLAG_READONLY << 3,
BUFFER_FLAG_DELTA_UNIT = GST_MINI_OBJECT_FLAG_READONLY << 4,
BUFFER_FLAG_LAST = GST_MINI_OBJECT_FLAG_READONLY << 8
}

enum | BufferCopyFlags { BUFFER_COPY_FLAGS = 1 << 0, BUFFER_COPY_TIMESTAMPS = 1 << 1, BUFFER_COPY_CAPS = 1 << 2 }
enum | BusFlags { BUS_FLUSHING = GST_OBJECT_FLAG_LAST << 0, BUS_FLAG_LAST = GST_OBJECT_FLAG_LAST << 1 }
enum | BusSyncReply { BUS_DROP, BUS_PASS, BUS_ASYNC }
| The result values for a Gst::Bus::SlotMessageSync. More...
enum | CddaBaseSrcMode { CDDA_BASE_SRC_MODE_NORMAL, CDDA_BASE_SRC_MODE_CONTINUOUS }
enum | CdParanoiaMode { PARANOIA_MODE_DISABLE = 1<<0, PARANOIA_MODE_FRAGMENT = 1<<1, PARANOIA_MODE_OVERLAP = 1<<2, PARANOIA_MODE_SCRATCH = 1<<3, PARANOIA_MODE_REPAIR = 1<<4, PARANOIA_MODE_FULL = 0xff }
enum | ClockEntryType { CLOCK_ENTRY_SINGLE, CLOCK_ENTRY_PERIODIC }
enum | ClockReturn { CLOCK_OK, CLOCK_EARLY, CLOCK_UNSCHEDULED, CLOCK_BUSY, CLOCK_BADTIME, CLOCK_ERROR, CLOCK_UNSUPPORTED }

enum

ClockFlags {
CLOCK_FLAG_CAN_DO_SINGLE_SYNC = GST_OBJECT_FLAG_LAST << 0,
CLOCK_FLAG_CAN_DO_SINGLE_ASYNC = GST_OBJECT_FLAG_LAST << 1,
CLOCK_FLAG_CAN_DO_PERIODIC_SYNC = GST_OBJECT_FLAG_LAST << 2,
CLOCK_FLAG_CAN_DO_PERIODIC_ASYNC = GST_OBJECT_FLAG_LAST << 3,
CLOCK_FLAG_CAN_SET_RESOLUTION = GST_OBJECT_FLAG_LAST << 4,
CLOCK_FLAG_CAN_SET_MASTER = GST_OBJECT_FLAG_LAST << 5,
CLOCK_FLAG_LAST = GST_OBJECT_FLAG_LAST << 8
}

enum | ColorBalanceType { COLOR_BALANCE_HARDWARE, COLOR_BALANCE_SOFTWARE }
enum | ElementFlags { ELEMENT_LOCKED_STATE = GST_OBJECT_FLAG_LAST << 0, ELEMENT_IS_SINK = GST_OBJECT_FLAG_LAST << 1, ELEMENT_UNPARENTING = GST_OBJECT_FLAG_LAST << 2, ELEMENT_FLAG_LAST = GST_OBJECT_FLAG_LAST << 16 }

enum

StateChange {
STATE_CHANGE_NULL_TO_READY = GST_STATE_CHANGE_NULL_TO_READY,
STATE_CHANGE_READY_TO_PAUSED = GST_STATE_CHANGE_READY_TO_PAUSED,
STATE_CHANGE_PAUSED_TO_PLAYING = GST_STATE_CHANGE_PAUSED_TO_PLAYING,
STATE_CHANGE_PLAYING_TO_PAUSED = GST_STATE_CHANGE_PLAYING_TO_PAUSED,
STATE_CHANGE_PAUSED_TO_READY = GST_STATE_CHANGE_PAUSED_TO_READY,
STATE_CHANGE_READY_TO_NULL = GST_STATE_CHANGE_READY_TO_NULL
}

enum | StateChangeReturn { STATE_CHANGE_FAILURE, STATE_CHANGE_SUCCESS, STATE_CHANGE_ASYNC, STATE_CHANGE_NO_PREROLL }
enum | MiniObjectFlags { MINI_OBJECT_FLAG_READONLY = 1<<0, MINI_OBJECT_FLAG_LAST = 1<<4 }
enum | State { STATE_VOID_PENDING, STATE_NULL, STATE_READY, STATE_PAUSED, STATE_PLAYING }

enum

EventType {
EVENT_UNKNOWN = GST_EVENT_UNKNOWN,
EVENT_FLUSH_START = GST_EVENT_FLUSH_START,
EVENT_FLUSH_STOP = GST_EVENT_FLUSH_STOP,
EVENT_EOS = GST_EVENT_EOS,
EVENT_NEWSEGMENT = GST_EVENT_NEWSEGMENT,
EVENT_TAG = GST_EVENT_TAG,
EVENT_BUFFERSIZE = GST_EVENT_BUFFERSIZE,
EVENT_QOS = GST_EVENT_QOS,
EVENT_SEEK = GST_EVENT_SEEK,
EVENT_NAVIGATION = GST_EVENT_NAVIGATION,
EVENT_LATENCY = GST_EVENT_LATENCY,
EVENT_CUSTOM_UPSTREAM = GST_EVENT_CUSTOM_UPSTREAM,
EVENT_CUSTOM_DOWNSTREAM = GST_EVENT_CUSTOM_DOWNSTREAM,
EVENT_CUSTOM_DOWNSTREAM_OOB = GST_EVENT_CUSTOM_DOWNSTREAM_OOB,
EVENT_CUSTOM_BOTH = GST_EVENT_CUSTOM_BOTH,
EVENT_CUSTOM_BOTH_OOB = GST_EVENT_CUSTOM_BOTH_OOB
}

enum | SeekType { SEEK_TYPE_NONE, SEEK_TYPE_CUR, SEEK_TYPE_SET, SEEK_TYPE_END }
enum | SeekFlags { SEEK_FLAG_NONE = 0, SEEK_FLAG_FLUSH = 1 << 0, SEEK_FLAG_ACCURATE = 1 << 1, SEEK_FLAG_KEY_UNIT = 1 << 2, SEEK_FLAG_SEGMENT = 1 << 3, SEEK_FLAG_SKIP = 1 << 4 }
enum | EventTypeFlags { EVENT_TYPE_UPSTREAM = 1 << 0, EVENT_TYPE_DOWNSTREAM = 1 << 1, EVENT_TYPE_SERIALIZED = 1 << 2 }
enum | FakeSinkStateError { FAKE_SINK_STATE_ERROR_NONE, FAKE_SINK_STATE_ERROR_NULL_READY, FAKE_SINK_STATE_ERROR_READY_PAUSED, FAKE_SINK_STATE_ERROR_PAUSED_PLAYING, FAKE_SINK_STATE_ERROR_PLAYING_PAUSED, FAKE_SINK_STATE_ERROR_PAUSED_READY, FAKE_SINK_STATE_ERROR_READY_NULL }
enum | FakeSrcDataType { FAKE_SRC_DATA_ALLOCATE = 1, FAKE_SRC_DATA_SUBBUFFER }
enum | FakeSrcSizeType { FAKE_SRC_SIZETYPE_EMPTY = 1, FAKE_SRC_SIZETYPE_FIXED, FAKE_SRC_SIZETYPE_RANDOM }
enum | FakeSrcFillType { FAKE_SRC_FILLTYPE_NOTHING = 1, FAKE_SRC_FILLTYPE_ZERO, FAKE_SRC_FILLTYPE_RANDOM, FAKE_SRC_FILLTYPE_PATTERN, FAKE_SRC_FILLTYPE_PATTERN_CONT }
enum | FileSinkBufferMode { FILE_SINK_BUFFER_MODE_DEFAULT = -1, FILE_SINK_BUFFER_MODE_FULL, FILE_SINK_BUFFER_MODE_LINE, FILE_SINK_BUFFER_MODE_UNBUFFERED }
enum | Format { FORMAT_UNDEFINED, FORMAT_DEFAULT, FORMAT_BYTES, FORMAT_TIME, FORMAT_BUFFERS, FORMAT_PERCENT }
enum | DPVersion { GDP_VERSION_0_2 = 1, GDP_VERSION_1_0 }
enum | IndexCertainty { INDEX_UNKNOWN, INDEX_CERTAIN, INDEX_FUZZY }
enum | IndexEntryType { INDEX_ENTRY_ID, INDEX_ENTRY_ASSOCIATION, INDEX_ENTRY_OBJECT, INDEX_ENTRY_FORMAT }
enum | IndexLookupMethod { INDEX_LOOKUP_EXACT, INDEX_LOOKUP_BEFORE, INDEX_LOOKUP_AFTER }
enum | AssocFlags { ASSOCIATION_FLAG_NONE = 0, ASSOCIATION_FLAG_KEY_UNIT = 1 << 0, ASSOCIATION_FLAG_DELTA_UNIT = 1 << 1, ASSOCIATION_FLAG_LAST = 1 << 8 }
enum | IndexResolverMethod { INDEX_RESOLVER_CUSTOM, INDEX_RESOLVER_GTYPE, INDEX_RESOLVER_PATH }
enum | IndexFlags { INDEX_WRITABLE = GST_OBJECT_FLAG_LAST << 0, INDEX_READABLE = GST_OBJECT_FLAG_LAST << 1, INDEX_FLAG_LAST = GST_OBJECT_FLAG_LAST << 8 }
enum | IteratorItem { ITERATOR_ITEM_SKIP, ITERATOR_ITEM_PASS, ITERATOR_ITEM_END }
enum | IteratorResult { ITERATOR_DONE, ITERATOR_OK, ITERATOR_RESYNC, ITERATOR_ERROR }

enum

MessageType {
MESSAGE_UNKNOWN = 0,
MESSAGE_EOS = 1 << 0,
MESSAGE_ERROR = 1 << 1,
MESSAGE_WARNING = 1 << 2,
MESSAGE_INFO = 1 << 3,
MESSAGE_TAG = 1 << 4,
MESSAGE_BUFFERING = 1 << 5,
MESSAGE_STATE_CHANGED = 1 << 6,
MESSAGE_STATE_DIRTY = 1 << 7,
MESSAGE_STEP_DONE = 1 << 8,
MESSAGE_CLOCK_PROVIDE = 1 << 9,
MESSAGE_CLOCK_LOST = 1 << 10,
MESSAGE_NEW_CLOCK = 1 << 11,
MESSAGE_STRUCTURE_CHANGE = 1 << 12,
MESSAGE_STREAM_STATUS = 1 << 13,
MESSAGE_APPLICATION = 1 << 14,
MESSAGE_ELEMENT = 1 << 15,
MESSAGE_SEGMENT_START = 1 << 16,
MESSAGE_SEGMENT_DONE = 1 << 17,
MESSAGE_DURATION = 1 << 18,
MESSAGE_LATENCY = 1 << 19,
MESSAGE_ASYNC_START = 1 << 20,
MESSAGE_ASYNC_DONE = 1 << 21,
MESSAGE_ANY = ~0
}

enum | MixerType { MIXER_HARDWARE, MIXER_SOFTWARE }
enum | MixerFlags { MIXER_FLAG_NONE = 0, MIXER_FLAG_AUTO_NOTIFICATIONS = 1<<0 }
enum | MixerMessageType { MIXER_MESSAGE_INVALID, MIXER_MESSAGE_MUTE_TOGGLED, MIXER_MESSAGE_RECORD_TOGGLED, MIXER_MESSAGE_VOLUME_CHANGED, MIXER_MESSAGE_OPTION_CHANGED, MIXER_MESSAGE_OPTIONS_LIST_CHANGED, MIXER_MESSAGE_MIXER_CHANGED }
enum | MixerTrackFlags { MIXER_TRACK_INPUT = 1<<0, MIXER_TRACK_OUTPUT = 1<<1, MIXER_TRACK_MUTE = 1<<2, MIXER_TRACK_RECORD = 1<<3, MIXER_TRACK_MASTER = 1<<4, MIXER_TRACK_SOFTWARE = 1<<5 }
enum | PadDirection { PAD_UNKNOWN, PAD_SRC, PAD_SINK }
enum | PadFlags { PAD_BLOCKED = GST_OBJECT_FLAG_LAST << 0, PAD_FLUSHING = GST_OBJECT_FLAG_LAST << 1, PAD_IN_GETCAPS = GST_OBJECT_FLAG_LAST << 2, PAD_IN_SETCAPS = GST_OBJECT_FLAG_LAST << 3, PAD_BLOCKING = GST_OBJECT_FLAG_LAST << 4, PAD_FLAG_LAST = GST_OBJECT_FLAG_LAST << 8 }
enum | PadLinkReturn { PAD_LINK_OK = 0, PAD_LINK_WRONG_HIERARCHY = -1, PAD_LINK_WAS_LINKED = -2, PAD_LINK_WRONG_DIRECTION = -3, PAD_LINK_NOFORMAT = -4, PAD_LINK_NOSCHED = -5, PAD_LINK_REFUSED = -6 }
enum | FlowReturn { FLOW_CUSTOM_SUCCESS = 100, FLOW_RESEND = 1, FLOW_OK = 0, FLOW_NOT_LINKED = -1, FLOW_WRONG_STATE = -2, FLOW_UNEXPECTED = -3, FLOW_NOT_NEGOTIATED = -4, FLOW_ERROR = -5, FLOW_NOT_SUPPORTED = -6, FLOW_CUSTOM_ERROR = -100 }
enum | ActivateMode { ACTIVATE_NONE, ACTIVATE_PUSH, ACTIVATE_PULL }
enum | PadTemplateFlags { PAD_TEMPLATE_FIXED = GST_OBJECT_FLAG_LAST << 0, PAD_TEMPLATE_LAST = GST_OBJECT_FLAG_LAST << 4 }
enum | PadPresence { PAD_ALWAYS, PAD_SOMETIMES, PAD_REQUEST }
enum | PlayFlags { PLAY_FLAG_VIDEO = 1 << 0, PLAY_FLAG_AUDIO = 1 << 1, PLAY_FLAG_TEXT = 1 << 2, PLAY_FLAG_VIS = 1 << 3, PLAY_FLAG_SOFT_VOLUME = 1 << 4, PLAY_FLAG_NATIVE_AUDIO = 1 << 5, PLAY_FLAG_NATIVE_VIDEO = 1 << 6 }
enum | Rank { RANK_NONE = 0, RANK_MARGINAL = 64, RANK_SECONDARY = 128, RANK_PRIMARY = 256 }
enum | QueryType { QUERY_NONE, QUERY_POSITION, QUERY_DURATION, QUERY_LATENCY, QUERY_JITTER, QUERY_RATE, QUERY_SEEKING, QUERY_SEGMENT, QUERY_CONVERT, QUERY_FORMATS, QUERY_BUFFERING, QUERY_CUSTOM, QUERY_URI }
enum | BufferingMode { BUFFERING_STREAM, BUFFERING_DOWNLOAD, BUFFERING_TIMESHIFT, BUFFERING_LIVE }
enum | QueueLeaky { QUEUE_LEAKY_NONE, QUEUE_LEAKY_UPSTREAM, QUEUE_LEAKY_DOWNSTREAM }
enum | TagMergeMode { TAG_MERGE_UNDEFINED, TAG_MERGE_REPLACE_ALL, TAG_MERGE_REPLACE, TAG_MERGE_APPEND, TAG_MERGE_PREPEND, TAG_MERGE_KEEP, TAG_MERGE_KEEP_ALL, TAG_MERGE_COUNT }
enum | TagFlag { TAG_FLAG_UNDEFINED, TAG_FLAG_META, TAG_FLAG_ENCODED, TAG_FLAG_DECODED, TAG_FLAG_COUNT }
enum | TaskState { TASK_STARTED, TASK_STOPPED, TASK_PAUSED }
enum | TeePullMode { TEE_PULL_MODE_NEVER, TEE_PULL_MODE_SINGLE }
enum | TextOverlayHAlign { TEXT_OVERLAY_HALIGN_LEFT, TEXT_OVERLAY_HALIGN_CENTER, TEXT_OVERLAY_HALIGN_RIGHT }
enum | TextOverlayVAlign { TEXT_OVERLAY_VALIGN_BASELINE, TEXT_OVERLAY_VALIGN_BOTTOM, TEXT_OVERLAY_VALIGN_TOP }
enum | TextOverlayWrapMode { TEXT_OVERLAY_WRAP_MODE_NONE = -1, TEXT_OVERLAY_WRAP_MODE_WORD, TEXT_OVERLAY_WRAP_MODE_CHAR, TEXT_OVERLAY_WRAP_MODE_WORD_CHAR }
enum | TextOverlayLineAlign { TEXT_OVERLAY_LINE_ALIGN_LEFT, TEXT_OVERLAY_LINE_ALIGN_CENTER, TEXT_OVERLAY_LINE_ALIGN_RIGHT }
enum | TheoraEncBorderMode { THEORA_ENC_BORDER_NONE, THEORA_ENC_BORDER_BLACK, THEORA_ENC_BORDER_MIRROR }
enum | TunerChannelFlags { TUNER_CHANNEL_INPUT = 1<<0, TUNER_CHANNEL_OUTPUT = 1<<1, TUNER_CHANNEL_FREQUENCY = 1<<2, TUNER_CHANNEL_AUDIO = 1<<3 }
enum | URIType { URI_UNKNOWN = GST_URI_UNKNOWN, URI_SINK = GST_URI_SINK, URI_SRC = GST_URI_SRC }
enum | VideoScaleMethod { VIDEO_SCALE_NEAREST, VIDEO_SCALE_BILINEAR, VIDEO_SCALE_4TAP }
enum | VideoTestSrcPattern { VIDEO_TEST_SRC_SMPTE, VIDEO_TEST_SRC_SNOW, VIDEO_TEST_SRC_BLACK, VIDEO_TEST_SRC_WHITE, VIDEO_TEST_SRC_RED, VIDEO_TEST_SRC_GREEN, VIDEO_TEST_SRC_BLUE, VIDEO_TEST_SRC_CHECKERS1, VIDEO_TEST_SRC_CHECKERS2, VIDEO_TEST_SRC_CHECKERS4, VIDEO_TEST_SRC_CHECKERS8, VIDEO_TEST_SRC_CIRCULAR, VIDEO_TEST_SRC_BLINK, VIDEO_TEST_SRC_SMPTE75, VIDEO_TEST_SRC_ZONE_PLATE }
enum | VideoTestSrcColorSpec { VIDEO_TEST_SRC_BT601, VIDEO_TEST_SRC_BT709 }

## Functions

BufferCopyFlags | operator| (BufferCopyFlags lhs, BufferCopyFlags rhs)
BufferCopyFlags | operator& (BufferCopyFlags lhs, BufferCopyFlags rhs)
BufferCopyFlags | operator^ (BufferCopyFlags lhs, BufferCopyFlags rhs)
BufferCopyFlags | operator~ (BufferCopyFlags flags)
BufferCopyFlags& | operator|= (BufferCopyFlags& lhs, BufferCopyFlags rhs)
BufferCopyFlags& | operator&= (BufferCopyFlags& lhs, BufferCopyFlags rhs)
BufferCopyFlags& | operator^= (BufferCopyFlags& lhs, BufferCopyFlags rhs)
guint | get_hours (ClockTime time)
| Get hour component of Gst::ClockTime.
guint | get_minutes (ClockTime time)
| Get minute component of Gst::ClockTime.
guint | get_seconds (ClockTime time)
| Get seconds component of Gst::ClockTime.
guint | get_milliseconds (ClockTime time)
| Get milliseconds component of Gst::ClockTime.
guint | get_microseconds (ClockTime time)
| Get microseconds component of Gst::ClockTime.
guint | get_nanoseconds (ClockTime time)
| Get nanoseconds component of Gst::ClockTime.
guint | get_fractional_seconds (ClockTime time)
| Get fractional component (milli, micro and nano seconds) of Gst::ClockTime.
MiniObjectFlags | operator| (MiniObjectFlags lhs, MiniObjectFlags rhs)
MiniObjectFlags | operator& (MiniObjectFlags lhs, MiniObjectFlags rhs)
MiniObjectFlags | operator^ (MiniObjectFlags lhs, MiniObjectFlags rhs)
MiniObjectFlags | operator~ (MiniObjectFlags flags)
MiniObjectFlags& | operator|= (MiniObjectFlags& lhs, MiniObjectFlags rhs)
MiniObjectFlags& | operator&= (MiniObjectFlags& lhs, MiniObjectFlags rhs)
MiniObjectFlags& | operator^= (MiniObjectFlags& lhs, MiniObjectFlags rhs)
Glib::QueryQuark | get_core_error_quark ()
| Get error domain for core system.
Glib::QueryQuark | get_library_error_quark ()
| Get error domain for library loading.
Glib::QueryQuark | get_resource_error_quark ()
| Get error domain for resource handling.
Glib::QueryQuark | get_stream_error_quark ()
| Get error domain for media stream processing.
SeekFlags | operator| (SeekFlags lhs, SeekFlags rhs)
SeekFlags | operator& (SeekFlags lhs, SeekFlags rhs)
SeekFlags | operator^ (SeekFlags lhs, SeekFlags rhs)
SeekFlags | operator~ (SeekFlags flags)
SeekFlags& | operator|= (SeekFlags& lhs, SeekFlags rhs)
SeekFlags& | operator&= (SeekFlags& lhs, SeekFlags rhs)
SeekFlags& | operator^= (SeekFlags& lhs, SeekFlags rhs)
EventTypeFlags | operator| (EventTypeFlags lhs, EventTypeFlags rhs)
EventTypeFlags | operator& (EventTypeFlags lhs, EventTypeFlags rhs)
EventTypeFlags | operator^ (EventTypeFlags lhs, EventTypeFlags rhs)
EventTypeFlags | operator~ (EventTypeFlags flags)
EventTypeFlags& | operator|= (EventTypeFlags& lhs, EventTypeFlags rhs)
EventTypeFlags& | operator&= (EventTypeFlags& lhs, EventTypeFlags rhs)
EventTypeFlags& | operator^= (EventTypeFlags& lhs, EventTypeFlags rhs)
Format | register_format (const Glib::ustring& nick, const Glib::ustring& description)
| Create a new Gst::Format based on the nick or return an already registered format with that nick.
Format | get_format (const Glib::ustring& nick)
| Return the format registered with the given nick.
bool | formats_contain (const Glib::ArrayHandle<Format>& formats, Format format)
| See if the given format is inside the array of formats.
bool | get_format_details (Format format, FormatDefinition& def)
| Get details about the given format.
IteratorBasic< const FormatDefinition > | iterate_format_definitions ()
| Iterate all the registered formats.
void | gst_wrap_init ()
| Initializes wrapping system of Gst::MiniObject derrived classes.
AssocFlags | operator| (AssocFlags lhs, AssocFlags rhs)
AssocFlags | operator& (AssocFlags lhs, AssocFlags rhs)
AssocFlags | operator^ (AssocFlags lhs, AssocFlags rhs)
AssocFlags | operator~ (AssocFlags flags)
AssocFlags& | operator|= (AssocFlags& lhs, AssocFlags rhs)
AssocFlags& | operator&= (AssocFlags& lhs, AssocFlags rhs)
AssocFlags& | operator^= (AssocFlags& lhs, AssocFlags rhs)
void | init (int& argc, char**& argv)
| Initializes gstreamermm parsing command line arguments.
void | init ()
| Initializes gstreamermm without parsing command line options.
bool | init_check (int& argc, char**& argv)
| Initializes gstreamermm gracefully parsing command line arguments.
bool | init_check ()
| Initializes gstreamermm gracefully without parsing command line arguments.
Glib::OptionGroup | get_option_group ()
| Returns a Glib::OptionGroup with GStreamer's argument specifications.
MessageType | operator| (MessageType lhs, MessageType rhs)
MessageType | operator& (MessageType lhs, MessageType rhs)
MessageType | operator^ (MessageType lhs, MessageType rhs)
MessageType | operator~ (MessageType flags)
MessageType& | operator|= (MessageType& lhs, MessageType rhs)
MessageType& | operator&= (MessageType& lhs, MessageType rhs)
MessageType& | operator^= (MessageType& lhs, MessageType rhs)
MixerFlags | operator| (MixerFlags lhs, MixerFlags rhs)
MixerFlags | operator& (MixerFlags lhs, MixerFlags rhs)
MixerFlags | operator^ (MixerFlags lhs, MixerFlags rhs)
MixerFlags | operator~ (MixerFlags flags)
MixerFlags& | operator|= (MixerFlags& lhs, MixerFlags rhs)
MixerFlags& | operator&= (MixerFlags& lhs, MixerFlags rhs)
MixerFlags& | operator^= (MixerFlags& lhs, MixerFlags rhs)
MixerTrackFlags | operator| (MixerTrackFlags lhs, MixerTrackFlags rhs)
MixerTrackFlags | operator& (MixerTrackFlags lhs, MixerTrackFlags rhs)
MixerTrackFlags | operator^ (MixerTrackFlags lhs, MixerTrackFlags rhs)
MixerTrackFlags | operator~ (MixerTrackFlags flags)
MixerTrackFlags& | operator|= (MixerTrackFlags& lhs, MixerTrackFlags rhs)
MixerTrackFlags& | operator&= (MixerTrackFlags& lhs, MixerTrackFlags rhs)
MixerTrackFlags& | operator^= (MixerTrackFlags& lhs, MixerTrackFlags rhs)
PlayFlags | operator| (PlayFlags lhs, PlayFlags rhs)
PlayFlags | operator& (PlayFlags lhs, PlayFlags rhs)
PlayFlags | operator^ (PlayFlags lhs, PlayFlags rhs)
PlayFlags | operator~ (PlayFlags flags)
PlayFlags& | operator|= (PlayFlags& lhs, PlayFlags rhs)
PlayFlags& | operator&= (PlayFlags& lhs, PlayFlags rhs)
PlayFlags& | operator^= (PlayFlags& lhs, PlayFlags rhs)
TunerChannelFlags | operator| (TunerChannelFlags lhs, TunerChannelFlags rhs)
TunerChannelFlags | operator& (TunerChannelFlags lhs, TunerChannelFlags rhs)
TunerChannelFlags | operator^ (TunerChannelFlags lhs, TunerChannelFlags rhs)
TunerChannelFlags | operator~ (TunerChannelFlags flags)
TunerChannelFlags& | operator|= (TunerChannelFlags& lhs, TunerChannelFlags rhs)
TunerChannelFlags& | operator&= (TunerChannelFlags& lhs, TunerChannelFlags rhs)
TunerChannelFlags& | operator^= (TunerChannelFlags& lhs, TunerChannelFlags rhs)
void | version (guint& major, guint& minor, guint& micro)
| Gets the version number of the gstreamermm library.
template<class T>
T::BaseObjectType* | unwrap (T* ptr)
| Get the underlying C instance from the C++ instance.
template<class T>
const T::BaseObjectType* | unwrap (const T* ptr)
| Get the underlying C instance from the C++ instance.
template<class T>
T::BaseObjectType* | unwrap (const Glib::RefPtr<T>& ptr)
| Get the underlying C instance from the C++ instance.
template<class T>
const T::BaseObjectType* | unwrap (const Glib::RefPtr<const T>& ptr)
| Get the underlying C instance from the C++ instance.
template<class T>
T::BaseObjectType* | unwrap_copy (const Glib::RefPtr<T>& ptr)
| Get the underlying C instance from the C++ instance and acquire a reference.
template<class T>
const T::BaseObjectType* | unwrap_copy (const Glib::RefPtr<const T>& ptr)
| Get the underlying C instance from the C++ instance and acquire a reference.
void | wrap_init ()
| Initializes the main gstreamermm wrapping system.

## Variables

const Glib::ustring | BASE_TRANSFORM_SINK_NAME = GST_BASE_TRANSFORM_SINK_NAME
| The name of the templates for the sink pad ("sink").
const Glib::ustring | BASE_TRANSFORM_SRC_NAME = GST_BASE_TRANSFORM_SRC_NAME
| The name of the templates for the source pad ("src").
const ClockTime | CLOCK_TIME_NONE = GST_CLOCK_TIME_NONE
| Constant to define an undefined clock time.
const ClockTime | SECOND = GST_SECOND
| Constant that defines one GStreamer second.
const ClockTime | MILLI_SECOND = GST_MSECOND
| Constant that defines one GStreamer millisecond.
const ClockTime | MICRO_SECOND = GST_USECOND
| Constant that defines one GStreamer microsecond.
const ClockTime | NANO_SECOND = GST_NSECOND
| Constant that defines one GStreamer nanosecond.
GLIBMM_API GQuark | quark_
GLIBMM_API GQuark | quark_cpp_wrapper_deleted_

## Typedef Documentation

typedef GstClockTime Gst::ClockTime

A datatype to hold a time, measured in nanoseconds.

typedef GstClockTimeDiff Gst::ClockTimeDiff

A datatype to hold a timedifference, measured in nanoseconds.

## Enumeration Type Documentation

enum Gst::EventType

Enumerator:

  EVENT_UNKNOWN |
  EVENT_FLUSH_START |
  EVENT_FLUSH_STOP |
  EVENT_EOS |
  EVENT_NEWSEGMENT |
  EVENT_TAG |
  EVENT_BUFFERSIZE |
  EVENT_QOS |
  EVENT_SEEK |
  EVENT_NAVIGATION |
  EVENT_LATENCY |
  EVENT_CUSTOM_UPSTREAM |
  EVENT_CUSTOM_DOWNSTREAM |
  EVENT_CUSTOM_DOWNSTREAM_OOB |
  EVENT_CUSTOM_BOTH |
  EVENT_CUSTOM_BOTH_OOB |

enum Gst::StateChange

Enumerator:

  STATE_CHANGE_NULL_TO_READY |
  STATE_CHANGE_READY_TO_PAUSED |
  STATE_CHANGE_PAUSED_TO_PLAYING |
  STATE_CHANGE_PLAYING_TO_PAUSED |
  STATE_CHANGE_PAUSED_TO_READY |
  STATE_CHANGE_READY_TO_NULL |

enum Gst::URIType

Enumerator:

  URI_UNKNOWN |
  URI_SINK |
  URI_SRC |

## Function Documentation

bool Gst::formats_contain | ( | const Glib::ArrayHandle< Format > & | formats,
|  | Format | format |
| ) |  |  |

See if the given format is inside the array of formats.

Parameters:

  | formats | The array of formats to search.
  | format | The format to find.

Returns:
  true If the format is found inside the array.

Glib::QueryQuark Gst::get_core_error_quark | ( |  | ) |

Get error domain for core system.

Errors in this domain will be from the Gst::CoreError enumeration.

Returns:
  The quark associated with the core error domain.

Format Gst::get_format | ( | const Glib::ustring & | nick | ) |

Return the format registered with the given nick.

Parameters:

  | nick | The nick of the format.

Returns:
  The format with nick or Gst::FORMAT_UNDEFINED if the format was not registered.

bool Gst::get_format_details | ( | Format | format,
|  | FormatDefinition & | def |
| ) |  |  |

Get details about the given format.

Parameters:

  | format | The format to get details of.
  | def | The Gst::FormatDefinition in which to store the details of the format.

Returns:
  true if successful, false otherwise. MT safe.

guint Gst::get_fractional_seconds | ( | ClockTime | time | ) |

Get fractional component (milli, micro and nano seconds) of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The fractional component of the Gst::ClockTime.

guint Gst::get_hours | ( | ClockTime | time | ) |

Get hour component of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The hour component of the Gst::ClockTime.

Glib::QueryQuark Gst::get_library_error_quark | ( |  | ) |

Get error domain for library loading.

Errors in this domain will be from the Gst::LibraryError enumeration.

Returns:
  The quark associated with the library error domain.

guint Gst::get_microseconds | ( | ClockTime | time | ) |

Get microseconds component of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The microseconds component of the Gst::ClockTime.

guint Gst::get_milliseconds | ( | ClockTime | time | ) |

Get milliseconds component of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The milliseconds component of the Gst::ClockTime.

guint Gst::get_minutes | ( | ClockTime | time | ) |

Get minute component of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The minute component of the Gst::ClockTime.

guint Gst::get_nanoseconds | ( | ClockTime | time | ) |

Get nanoseconds component of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The nanoseconds component of the Gst::ClockTime.

Glib::OptionGroup Gst::get_option_group | ( |  | ) |

Returns a Glib::OptionGroup with GStreamer's argument specifications.

The group is set up to use standard GOption callbacks, so when using this group in combination with GOption parsing methods, all argument parsing and initialization is automated.

This function is useful if you want to integrate GStreamer with other libraries that use GOption (see g_option_context_add_group() ).

If you use this function, you should make sure you initialise the GLib threading system as one of the very first things in your program.

Returns:
  A pointer to GStreamer's option group.

Glib::QueryQuark Gst::get_resource_error_quark | ( |  | ) |

Get error domain for resource handling.

Errors in this domain will be from the Gst::ResourceError enumeration.

Returns:
  The quark associated with the resource error domain.

guint Gst::get_seconds | ( | ClockTime | time | ) |

Get seconds component of Gst::ClockTime.

Parameters:

  | time | The Gst::ClockTime to parse.

Returns:
  The seconds component of the Gst::ClockTime.

Glib::QueryQuark Gst::get_stream_error_quark | ( |  | ) |

Get error domain for media stream processing.

Errors in this domain will be from the Gst::StreamError enumeration.

Returns:
  The quark associated with the media stream error domain.

void Gst::gst_wrap_init | ( |  | ) |

Initializes wrapping system of Gst::MiniObject derrived classes.

There is no need to use this function directly; instead use Gst::init() or Gst::init_check().

void Gst::init | ( |  | ) |

Initializes gstreamermm without parsing command line options.

Either the Gst::init() or Gst::init_check() functions with command line parsing should be called to initialize gstreamermm before calling any other GLib functions. If this is not an option, your program must initialize the GLib thread system using Glib::thread_init() before any other GLib functions are called and use either this function or Gst::init_check() without the command line arguments before calling any gstreamermm functions. GLib thread initialization can be done as follows:

     if (!Glib::thread_supported ())
       Glib::thread_init ();
     ...

Note: This function will terminate your program if it was unable to initialize GStreamer for some reason. If you want your program to fall back, use Gst::init_check() instead.

void Gst::init | ( | int & | argc,
|  | char **& | argv |
| ) |  |  |

Initializes gstreamermm parsing command line arguments.

Either this function or Gst::init_check() with command line parsing should be called to initialize gstreamermm before calling any other GLib functions. If this is not an option, your program must initialize the GLib thread system using Glib::thread_init() before any other GLib functions are called and use either Gst::init(), or Gst::init_check() without the command line arguments before calling any gstreamermm functions. GLib thread initialization can be done as follows:

     if (!Glib::thread_supported ())
       Glib::thread_init ();
     ...

Note: This function will terminate your program if it was unable to initialize GStreamer for some reason. If you want your program to fall back, use Gst::init_check() instead.

WARNING: This function does not work in the same way as corresponding functions in other glib-style libraries, such as gtk_init(). In particular, unknown command line options cause this function to abort program execution.

Parameters:

  | argc | Reference to application's argc.
  | argv | Reference to application's argv.

bool Gst::init_check | ( |  | ) |

Initializes gstreamermm gracefully without parsing command line arguments.

Either the Gst::init() or Gst::init_check() functions with command line parsing should be called to initialize gstreamermm before calling any other GLib functions. If this is not an option, your program must initialize the GLib thread system using Glib::thread_init() before any other GLib functions are called and use either this function or Gst::init() without the command line arguments before calling any gstreamermm functions. GLib thread initialization can be done as follows:

     if (!Glib::thread_supported ())
       Glib::thread_init ();
     ...

This function will return false if GStreamer could not be initialized for some reason. If you want your program to fail fatally, use Gst::init() instead.

Returns:
  true if GStreamer could be initialized.

Exceptions:

  | Glib::Error |

bool Gst::init_check | ( | int & | argc,
|  | char **& | argv |
| ) |  |  |

Initializes gstreamermm gracefully parsing command line arguments.

Either this function or Gst::init() with command line parsing should be called to initialize gstreamermm before calling any other GLib functions. If this is not an option, your program must initialize the GLib thread system using Glib::thread_init() before any other GLib functions are called and use either Gst::init() or Gst::init_check() without the command line arguments before calling any gstreamermm functions. GLib thread initialization can be done as follows:

     if (!Glib::thread_supported ())
       Glib::thread_init ();
     ...

This function will return false if GStreamer could not be initialized for some reason. If you want your program to fail fatally, use Gst::init() instead.

Parameters:

  | argc | Reference to application's argc.
  | argv | Reference to application's argv.

Returns:
  true if GStreamer could be initialized.

Exceptions:

  | Glib::Error |

IteratorBasic<const FormatDefinition> Gst::iterate_format_definitions | ( |  | ) |

Iterate all the registered formats.

The format definitions are read only.

Returns:
  a Gst::IteratorBasic of Gst::FormatDefinition.

Format Gst::register_format | ( | const Glib::ustring & | nick,
|  | const Glib::ustring & | description |
| ) |  |  |

Create a new Gst::Format based on the nick or return an already registered format with that nick.

Parameters:

  | nick | The nick of the new format.
  | description | The description of the new format.

Returns:
  A new Gst::Format or an already registered format with the same nick. MT safe.

template <class T>

const T::BaseObjectType* Gst::unwrap | ( | const Glib::RefPtr< const T > & | ptr | ) | `[inline]`

Get the underlying C instance from the C++ instance.

This is just like calling gobj(), but it does its own check for a NULL pointer.

template <class T>

T::BaseObjectType* Gst::unwrap | ( | const Glib::RefPtr< T > & | ptr | ) | `[inline]`

Get the underlying C instance from the C++ instance.

This is just like calling gobj(), but it does its own check for a NULL pointer.

template <class T>

const T::BaseObjectType* Gst::unwrap | ( | const T * | ptr | ) | `[inline]`

Get the underlying C instance from the C++ instance.

This is just like calling gobj(), but it does its own check for a NULL pointer.

template <class T>

T::BaseObjectType* Gst::unwrap | ( | T * | ptr | ) | `[inline]`

Get the underlying C instance from the C++ instance.

This is just like calling gobj(), but it does its own check for a NULL pointer.

template <class T>

const T::BaseObjectType* Gst::unwrap_copy | ( | const Glib::RefPtr< const T > & | ptr | ) | `[inline]`

Get the underlying C instance from the C++ instance and acquire a reference.

This is just like calling gobj_copy(), but it does its own check for a NULL pointer.

template <class T>

T::BaseObjectType* Gst::unwrap_copy | ( | const Glib::RefPtr< T > & | ptr | ) | `[inline]`

Get the underlying C instance from the C++ instance and acquire a reference.

This is just like calling gobj_copy(), but it does its own check for a NULL pointer.

void Gst::version | ( | guint & | major,
|  | guint & | minor,
|  | guint & | micro |
| ) |  |  |

Gets the version number of the gstreamermm library.

Parameters:

  | major | Pointer to a guint to store the major version number.
  | minor | Pointer to a guint to store the minor version number.
  | micro | Pointer to a guint to store the micro version number.

void Gst::wrap_init | ( |  | ) |

Initializes the main gstreamermm wrapping system.

There's no need to use this function directly; instead use Gst::init() or Gst::init_check().

## Variable Documentation

const Glib::ustring Gst::BASE_TRANSFORM_SINK_NAME = GST_BASE_TRANSFORM_SINK_NAME

The name of the templates for the sink pad ("sink").

const Glib::ustring Gst::BASE_TRANSFORM_SRC_NAME = GST_BASE_TRANSFORM_SRC_NAME

The name of the templates for the source pad ("src").

const ClockTime Gst::CLOCK_TIME_NONE = GST_CLOCK_TIME_NONE

Constant to define an undefined clock time.

const ClockTime Gst::MICRO_SECOND = GST_USECOND

Constant that defines one GStreamer microsecond.

const ClockTime Gst::MILLI_SECOND = GST_MSECOND

Constant that defines one GStreamer millisecond.

const ClockTime Gst::NANO_SECOND = GST_NSECOND

Constant that defines one GStreamer nanosecond.

GLIBMM_API GQuark Gst::quark_

GLIBMM_API GQuark Gst::quark_cpp_wrapper_deleted_

const ClockTime Gst::SECOND = GST_SECOND

Constant that defines one GStreamer second.